Index: /pjproject/trunk/pjsip/src/pjsua/pjsua_core.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua/pjsua_core.c	(revision 235)
+++ /pjproject/trunk/pjsip/src/pjsua/pjsua_core.c	(revision 236)
@@ -46,4 +46,6 @@
 void pjsua_default(void)
 {
+    unsigned i;
+
 
     /* Normally need another thread for console application, because main 
@@ -54,10 +56,8 @@
 
     /* Default transport settings: */
-
     pjsua.sip_port = 5060;
 
 
     /* Default logging settings: */
-
     pjsua.log_level = 5;
     pjsua.app_log_level = 4;
@@ -65,31 +65,27 @@
 		      PJ_LOG_HAS_MICRO_SEC | PJ_LOG_HAS_NEWLINE;
 
+
     /* Default: do not use STUN: */
-
     pjsua.stun_port1 = pjsua.stun_port2 = 0;
 
-    /* Default URIs: */
-
-    pjsua.local_uri = pj_str(PJSUA_LOCAL_URI);
-
-    /* Default registration timeout: */
-
-    pjsua.reg_timeout = 55;
-
-    /* Default maximum conference ports: */
-
-    pjsua.max_ports = 8;
-
-    /* Init route set list: */
-
-    pj_list_init(&pjsua.route_set);
-
-    /* Init invite session list: */
-
-    pj_list_init(&pjsua.inv_list);
+    /* Init accounts: */
+    pjsua.acc_cnt = 1;
+    for (i=0; i<PJ_ARRAY_SIZE(pjsua.acc); ++i) {
+	pjsua.acc[i].index = i;
+	pjsua.acc[i].local_uri = pj_str(PJSUA_LOCAL_URI);
+	pjsua.acc[i].reg_timeout = 55;
+	pj_list_init(&pjsua.acc[i].route_set);
+	pj_list_init(&pjsua.acc[i].pres_srv_list);
+    }
+
+    /* Init call array: */
+    for (i=0; i<PJ_ARRAY_SIZE(pjsua.calls); ++i)
+	pjsua.calls[i].index = i;
+
+    /* Default max nb of calls. */
+    pjsua.max_calls = 4;
 
     /* Init server presence subscription list: */
     
-    pj_list_init(&pjsua.pres_srv_list);
 
 }
@@ -111,6 +107,5 @@
     if (rdata->msg_info.msg->line.req.method.id == PJSIP_INVITE_METHOD) {
 
-	return pjsua_inv_on_incoming(rdata);
-
+	return pjsua_call_on_incoming(rdata);
     }
 
@@ -146,5 +141,5 @@
 	RTP_START_PORT = 4000,
 	RTP_RANDOM_START = 2,
-	RTP_RETRY = 20 
+	RTP_RETRY = 100
     };
     enum {
@@ -241,14 +236,17 @@
 		pj_memcpy(&mapped_addr[i], &addr, sizeof(addr));
 
-	    if (sip)
-		mapped_addr[SIP_SOCK].sin_port = pj_htons((pj_uint16_t)pjsua.sip_port);
-	    mapped_addr[RTP_SOCK].sin_port = pj_htons((pj_uint16_t)rtp_port);
-	    mapped_addr[RTCP_SOCK].sin_port = pj_htons((pj_uint16_t)(rtp_port+1));
+	    if (sip) {
+		mapped_addr[SIP_SOCK].sin_port = 
+		    pj_htons((pj_uint16_t)pjsua.sip_port);
+	    }
+	    mapped_addr[RTP_SOCK].sin_port=pj_htons((pj_uint16_t)rtp_port);
+	    mapped_addr[RTCP_SOCK].sin_port=pj_htons((pj_uint16_t)(rtp_port+1));
 	    break;
+
 	} else {
-	    status = pj_stun_get_mapped_addr( &pjsua.cp.factory, 3, sock,
-					      &pjsua.stun_srv1, pjsua.stun_port1,
-					      &pjsua.stun_srv2, pjsua.stun_port2,
-					      mapped_addr);
+	    status=pj_stun_get_mapped_addr(&pjsua.cp.factory, 3, sock,
+					   &pjsua.stun_srv1, pjsua.stun_port1,
+					   &pjsua.stun_srv2, pjsua.stun_port2,
+					   mapped_addr);
 	    if (status != PJ_SUCCESS) {
 		pjsua_perror(THIS_FILE, "STUN error", status);
@@ -256,14 +254,21 @@
 	    }
 
-	    if (pj_ntohs(mapped_addr[2].sin_port) == pj_ntohs(mapped_addr[1].sin_port)+1)
+	    if (pj_ntohs(mapped_addr[2].sin_port) == 
+		pj_ntohs(mapped_addr[1].sin_port)+1)
+	    {
 		break;
-
-	    pj_sock_close(sock[RTP_SOCK]); sock[RTP_SOCK] = PJ_INVALID_SOCKET;
-	    pj_sock_close(sock[RTCP_SOCK]); sock[RTCP_SOCK] = PJ_INVALID_SOCKET;
+	    }
+
+	    pj_sock_close(sock[RTP_SOCK]); 
+	    sock[RTP_SOCK] = PJ_INVALID_SOCKET;
+
+	    pj_sock_close(sock[RTCP_SOCK]); 
+	    sock[RTCP_SOCK] = PJ_INVALID_SOCKET;
 	}
     }
 
     if (sock[RTP_SOCK] == PJ_INVALID_SOCKET) {
-	PJ_LOG(1,(THIS_FILE, "Unable to find appropriate RTP/RTCP ports combination"));
+	PJ_LOG(1,(THIS_FILE, 
+		  "Unable to find appropriate RTP/RTCP ports combination"));
 	goto on_error;
     }
@@ -271,5 +276,7 @@
     if (sip) {
 	pjsua.sip_sock = sock[SIP_SOCK];
-	pj_memcpy(&pjsua.sip_sock_name, &mapped_addr[SIP_SOCK], sizeof(pj_sockaddr_in));
+	pj_memcpy(&pjsua.sip_sock_name, 
+		  &mapped_addr[SIP_SOCK], 
+		  sizeof(pj_sockaddr_in));
     } else {
 	pj_sock_close(sock[0]);
@@ -392,27 +399,10 @@
     /* Initialize invite session module: */
 
-    {
-	
-	/* Initialize invite session callback. */
-	pjsip_inv_callback inv_cb;
-
-	pj_memset(&inv_cb, 0, sizeof(inv_cb));
-	inv_cb.on_state_changed = &pjsua_inv_on_state_changed;
-	inv_cb.on_new_session = &pjsua_inv_on_new_session;
-	inv_cb.on_media_update = &pjsua_inv_on_media_update;
-	inv_cb.on_rx_offer = &pjsua_inv_on_rx_offer;
-	inv_cb.on_tsx_state_changed = &pjsua_inv_on_tsx_state_changed;
-
-
-	/* Initialize invite session module: */
-	status = pjsip_inv_usage_init(pjsua.endpt, &pjsua.mod, &inv_cb);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Invite usage initialization error", 
-			 status);
-	    goto on_error;
-	}
-
-    }
-
+    status = pjsua_call_init();
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Invite usage initialization error", 
+		     status);
+	goto on_error;
+    }
 
     /* Done */
@@ -521,5 +511,6 @@
     /* Init conference bridge. */
 
-    status = pjmedia_conf_create(pjsua.pool, pjsua.max_ports, 
+    status = pjmedia_conf_create(pjsua.pool, 
+				 pjsua.max_calls+PJSUA_CONF_MORE_PORTS, 
 				 8000, 160, 16, &pjsua.mconf);
     if (status != PJ_SUCCESS) {
@@ -548,4 +539,65 @@
 
 
+/*
+ * Find account for incoming request.
+ */
+int pjsua_find_account_for_incoming(pjsip_rx_data *rdata)
+{
+    pjsip_uri *uri;
+    pjsip_sip_uri *sip_uri;
+    int acc_index;
+
+    uri = rdata->msg_info.to->uri;
+
+    /* Just return account #0 if To URI is not SIP: */
+    if (!PJSIP_URI_SCHEME_IS_SIP(uri) && 
+	!PJSIP_URI_SCHEME_IS_SIPS(uri)) 
+    {
+	return 0;
+    }
+
+
+    sip_uri = (pjsip_sip_uri*)pjsip_uri_get_uri(uri);
+
+    /* Find account which has matching username and domain. */
+    for (acc_index=0; acc_index < pjsua.acc_cnt; ++acc_index) {
+
+	pjsua_acc *acc = &pjsua.acc[acc_index];
+
+	if (pj_stricmp(&acc->user_part, &sip_uri->user)==0 &&
+	    pj_stricmp(&acc->host_part, &sip_uri->host)==0) 
+	{
+	    /* Match ! */
+	    return acc_index;
+	}
+    }
+
+    /* No matching, try match domain part only. */
+    for (acc_index=0; acc_index < pjsua.acc_cnt; ++acc_index) {
+
+	pjsua_acc *acc = &pjsua.acc[acc_index];
+
+	if (pj_stricmp(&acc->host_part, &sip_uri->host)==0) {
+	    /* Match ! */
+	    return acc_index;
+	}
+    }
+
+    /* Still no match, just return account #0 */
+    return 0;
+}
+
+
+/*
+ * Find account for outgoing request.
+ */
+int pjsua_find_account_for_outgoing(const pj_str_t *url)
+{
+    PJ_UNUSED_ARG(url);
+
+    /* Just use account #0 */
+    return 0;
+}
+
 
 /*
@@ -589,9 +641,16 @@
 
     /* Init sockets (STUN etc): */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua.med_sock_info); ++i) {
-	status = init_sockets(i==0, &pjsua.med_sock_info[i]);
+    for (i=0; i<(int)pjsua.max_calls; ++i) {
+	status = init_sockets(i==0, &pjsua.calls[i].skinfo);
 	if (status != PJ_SUCCESS) {
 	    pjsua_perror(THIS_FILE, "init_sockets() has returned error", 
 			 status);
+	    --i;
+	    if (i >= 0)
+		pj_sock_close(pjsua.sip_sock);
+	    while (i >= 0) {
+		pj_sock_close(pjsua.calls[i].skinfo.rtp_sock);
+		pj_sock_close(pjsua.calls[i].skinfo.rtcp_sock);
+	    }
 	    return status;
 	}
@@ -624,22 +683,13 @@
 
     /* Initialize Contact URI, if one is not specified: */
-
-    if (pjsua.contact_uri.slen == 0 && pjsua.local_uri.slen) {
+    for (i=0; i<pjsua.acc_cnt; ++i) {
 
 	pjsip_uri *uri;
 	pjsip_sip_uri *sip_uri;
-	char contact[128];
-	int len;
-
-	/* The local Contact is the username@ip-addr, where
-	 *  - username is taken from the local URI,
-	 *  - ip-addr in UDP transport's address name (which may have been
-	 *    resolved from STUN.
-	 */
-	
+
 	/* Need to parse local_uri to get the elements: */
 
-	uri = pjsip_parse_uri(pjsua.pool, pjsua.local_uri.ptr, 
-			      pjsua.local_uri.slen, 0);
+	uri = pjsip_parse_uri(pjsua.pool, pjsua.acc[i].local_uri.ptr,
+			      pjsua.acc[i].local_uri.slen, 0);
 	if (uri == NULL) {
 	    pjsua_perror(THIS_FILE, "Invalid local URI", 
@@ -648,8 +698,9 @@
 	}
 
-
 	/* Local URI MUST be a SIP or SIPS: */
 
-	if (!PJSIP_URI_SCHEME_IS_SIP(uri) && !PJSIP_URI_SCHEME_IS_SIPS(uri)) {
+	if (!PJSIP_URI_SCHEME_IS_SIP(uri) && 
+	    !PJSIP_URI_SCHEME_IS_SIPS(uri)) 
+	{
 	    pjsua_perror(THIS_FILE, "Invalid local URI", 
 			 PJSIP_EINVALIDSCHEME);
@@ -662,37 +713,52 @@
 	sip_uri = (pjsip_sip_uri*) pjsip_uri_get_uri(uri);
 
-	
-	/* Build temporary contact string. */
-
-	if (sip_uri->user.slen) {
-
-	    /* With the user part. */
-	    len = pj_snprintf(contact, sizeof(contact),
-			      "<sip:%.*s@%.*s:%d>",
-			      (int)sip_uri->user.slen,
-			      sip_uri->user.ptr,
-			      (int)udp_transport->local_name.host.slen,
-			      udp_transport->local_name.host.ptr,
-			      udp_transport->local_name.port);
-	} else {
-
-	    /* Without user part */
-
-	    len = pj_snprintf(contact, sizeof(contact),
-			      "<sip:%.*s:%d>",
-			      (int)udp_transport->local_name.host.slen,
-			      udp_transport->local_name.host.ptr,
-			      udp_transport->local_name.port);
-	}
-
-	if (len < 1 || len >= sizeof(contact)) {
-	    pjsua_perror(THIS_FILE, "Invalid Contact", PJSIP_EURITOOLONG);
-	    return PJSIP_EURITOOLONG;
-	}
-
-	/* Duplicate Contact uri. */
-
-	pj_strdup2(pjsua.pool, &pjsua.contact_uri, contact);
-
+	pjsua.acc[i].user_part = sip_uri->user;
+	pjsua.acc[i].host_part = sip_uri->host;
+
+	if (pjsua.acc[i].contact_uri.slen == 0 && 
+	    pjsua.acc[i].local_uri.slen) 
+	{
+	    char contact[128];
+	    int len;
+
+	    /* The local Contact is the username@ip-addr, where
+	     *  - username is taken from the local URI,
+	     *  - ip-addr in UDP transport's address name (which may have been
+	     *    resolved from STUN.
+	     */
+	    
+	    /* Build temporary contact string. */
+
+	    if (sip_uri->user.slen) {
+
+		/* With the user part. */
+		len = pj_snprintf(contact, sizeof(contact),
+				  "<sip:%.*s@%.*s:%d>",
+				  (int)sip_uri->user.slen,
+				  sip_uri->user.ptr,
+				  (int)udp_transport->local_name.host.slen,
+				  udp_transport->local_name.host.ptr,
+				  udp_transport->local_name.port);
+	    } else {
+
+		/* Without user part */
+
+		len = pj_snprintf(contact, sizeof(contact),
+				  "<sip:%.*s:%d>",
+				  (int)udp_transport->local_name.host.slen,
+				  udp_transport->local_name.host.ptr,
+				  udp_transport->local_name.port);
+	    }
+
+	    if (len < 1 || len >= sizeof(contact)) {
+		pjsua_perror(THIS_FILE, "Invalid Contact", PJSIP_EURITOOLONG);
+		return PJSIP_EURITOOLONG;
+	    }
+
+	    /* Duplicate Contact uri. */
+
+	    pj_strdup2(pjsua.pool, &pjsua.acc[i].contact_uri, contact);
+
+	}
     }
 
@@ -715,5 +781,7 @@
 	}
 
-	pj_list_push_back(&pjsua.route_set, route);
+	for (i=0; i<pjsua.acc_cnt; ++i) {
+	    pj_list_push_front(&pjsua.acc[i].route_set, route);
+	}
     }
 
@@ -737,12 +805,20 @@
 
     /* Create client registration session: */
-
-    status = pjsua_regc_init();
-    if (status != PJ_SUCCESS)
-	return status;
-
-    /* Perform registration, if required. */
-    if (pjsua.regc) {
-	pjsua_regc_update(1);
+    for (i=0; i<pjsua.acc_cnt; ++i) {
+	status = pjsua_regc_init(i);
+	if (status != PJ_SUCCESS)
+	    return status;
+
+	/* Perform registration, if required. */
+	if (pjsua.acc[i].regc) {
+	    pjsua_regc_update(i, 1);
+	}
+    }
+
+
+    /* Find account for outgoing preence subscription */
+    for (i=0; i<pjsua.buddy_cnt; ++i) {
+	pjsua.buddies[i].acc_index = 
+	    pjsua_find_account_for_outgoing(&pjsua.buddies[i].uri);
     }
 
@@ -777,4 +853,17 @@
     /* Signal threads to quit: */
     pjsua.quit_flag = 1;
+
+    /* Terminate all calls. */
+    pjsua_inv_shutdown();
+
+    /* Terminate all presence subscriptions. */
+    pjsua_pres_shutdown();
+
+    /* Unregister, if required: */
+    for (i=0; i<pjsua.acc_cnt; ++i) {
+	if (pjsua.acc[i].regc) {
+	    pjsua_regc_update(i, 0);
+	}
+    }
 
     /* Wait worker threads to quit: */
@@ -789,15 +878,4 @@
 
 
-    /* Terminate all calls. */
-    pjsua_inv_shutdown();
-
-    /* Terminate all presence subscriptions. */
-    pjsua_pres_shutdown();
-
-    /* Unregister, if required: */
-    if (pjsua.regc) {
-	pjsua_regc_update(0);
-    }
-
     /* Wait for some time to allow unregistration to complete: */
     PJ_LOG(4,(THIS_FILE, "Shutting down..."));
Index: /pjproject/trunk/pjsip/src/pjsua/pjsua_opt.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua/pjsua_opt.c	(revision 235)
+++ /pjproject/trunk/pjsip/src/pjsua/pjsua_opt.c	(revision 236)
@@ -44,6 +44,4 @@
     puts("  pjsua [options]");
     puts("");
-    puts("  [sip-url]   Default URL to invite.");
-    puts("");
     puts("General options:");
     puts("  --help              Display this help screen");
@@ -56,27 +54,34 @@
     puts("  --app-log-level=N   Set log max level for stdout display to N");
     puts("");
+    puts("SIP Account options:");
+    puts("  --id=url            Set the URL of local ID (used in From header)");
+    puts("  --contact=url       Override the Contact information");
+    puts("  --proxy=url         Set the URL of proxy server");
+    puts("");
+    puts("SIP Account Registration Options:");
+    puts("  --registrar=url     Set the URL of registrar server");
+    puts("  --reg-timeout=secs  Set registration interval to secs (default 3600)");
+    puts("");
+    puts("SIP Account Control:");
+    puts("  --next-account      Add more account");
+    puts("");
     puts("Authentication options:");
     puts("  --realm=string      Set realm");
     puts("  --username=string   Set authentication username");
     puts("  --password=string   Set authentication password");
-    puts("");
-    puts("SIP options:");
-    puts("  --id=url            Set the URL of local ID (used in From header)");
-    puts("  --contact=url       Override the Contact information");
-    puts("  --proxy=url         Set the URL of proxy server");
-    //puts("  --outbound=url      Set the URL of outbound proxy server");
-    puts("");
-    puts("Registration Options:");
-    puts("  --registrar=url     Set the URL of registrar server");
-    puts("  --reg-timeout=secs  Set registration interval to secs (default 3600)");
+    puts("  --next-cred         Add more credential");
     puts("");
     puts("Transport Options:");
-    puts("  --local-port=port   Set TCP/UDP port");
+    puts("  --local-port=port        Set TCP/UDP port");
+    puts("  --outbound=url           Set the URL of outbound proxy server");
     puts("  --use-stun1=host[:port]");
-    puts("  --use-stun2=host[:port]  Use STUN and set host name and port of STUN servers");
+    puts("  --use-stun2=host[:port]  Resolve local IP with the specified STUN servers");
     puts("");
     puts("Media Options:");
     puts("  --null-audio        Use NULL audio device");
-    //puts("  --wav-file=file     Play WAV file in conference bridge");
+    puts("  --play-file=file    Play WAV file in conference bridge");
+    puts("  --auto-play         Automatically play the file (to incoming calls only)");
+    puts("  --auto-loop         Automatically loop incoming RTP to outgoing RTP");
+    puts("  --auto-conf         Automatically put incoming calls to conference");
     puts("");
     puts("Buddy List (can be more than one):");
@@ -85,5 +90,5 @@
     puts("User Agent options:");
     puts("  --auto-answer=code  Automatically answer incoming calls with code (e.g. 200)");
-    puts("  --auto-play=file    Automatically play WAVE file to incoming calls");
+    puts("  --max-calls=N       Maximum number of concurrent calls (default:4, max:255)");
     puts("");
     fflush(stdout);
@@ -200,5 +205,9 @@
 	   OPT_USE_STUN1, OPT_USE_STUN2, 
 	   OPT_ADD_BUDDY, OPT_OFFER_X_MS_MSG, OPT_NO_PRESENCE,
-	   OPT_AUTO_ANSWER, OPT_AUTO_HANGUP, OPT_AUTO_PLAY};
+	   OPT_AUTO_ANSWER, OPT_AUTO_HANGUP, OPT_AUTO_PLAY, OPT_AUTO_LOOP,
+	   OPT_AUTO_CONF,
+	   OPT_PLAY_FILE,
+	   OPT_NEXT_ACCOUNT, OPT_NEXT_CRED, OPT_MAX_CALLS,
+    };
     struct option long_options[] = {
 	{ "config-file",1, 0, OPT_CONFIG_FILE},
@@ -226,8 +235,16 @@
 	{ "auto-answer",1, 0, OPT_AUTO_ANSWER},
 	{ "auto-hangup",1, 0, OPT_AUTO_HANGUP},
-	{ "auto-play",  1, 0, OPT_AUTO_PLAY},
+	{ "auto-play",  0, 0, OPT_AUTO_PLAY},
+	{ "auto-loop",  0, 0, OPT_AUTO_LOOP},
+	{ "auto-conf",  0, 0, OPT_AUTO_CONF},
+	{ "play-file",  1, 0, OPT_PLAY_FILE},
+	{ "next-account",0,0, OPT_NEXT_ACCOUNT},
+	{ "next-cred",	0, 0, OPT_NEXT_CRED},
+	{ "max-calls",	1, 0, OPT_MAX_CALLS},
 	{ NULL, 0, 0, 0}
     };
     pj_status_t status;
+    pjsua_acc *cur_acc;
+    pjsip_cred_info *cur_cred;
     char *config_file = NULL;
 
@@ -248,4 +265,8 @@
 	    return status;
     }
+
+
+    cur_acc = &pjsua.acc[0];
+    cur_cred = &pjsua.cred_info[0];
 
 
@@ -308,5 +329,5 @@
 		return PJ_EINVAL;
 	    }
-	    pjsua.proxy = pj_str(optarg);
+	    cur_acc->proxy = pj_str(optarg);
 	    break;
 
@@ -324,10 +345,10 @@
 		return PJ_EINVAL;
 	    }
-	    pjsua.registrar_uri = pj_str(optarg);
+	    cur_acc->reg_uri = pj_str(optarg);
 	    break;
 
 	case OPT_REG_TIMEOUT:   /* reg-timeout */
-	    pjsua.reg_timeout = pj_strtoul(pj_cstr(&tmp,optarg));
-	    if (pjsua.reg_timeout < 1 || pjsua.reg_timeout > 3600) {
+	    cur_acc->reg_timeout = pj_strtoul(pj_cstr(&tmp,optarg));
+	    if (cur_acc->reg_timeout < 1 || cur_acc->reg_timeout > 3600) {
 		printf("Error: invalid value for --reg-timeout (expecting 1-3600)\n");
 		return PJ_EINVAL;
@@ -340,5 +361,5 @@
 		return PJ_EINVAL;
 	    }
-	    pjsua.local_uri = pj_str(optarg);
+	    cur_acc->local_uri = pj_str(optarg);
 	    break;
 
@@ -348,21 +369,31 @@
 		return PJ_EINVAL;
 	    }
-	    pjsua.contact_uri = pj_str(optarg);
+	    cur_acc->contact_uri = pj_str(optarg);
+	    break;
+
+	case OPT_NEXT_ACCOUNT: /* Add more account. */
+	    pjsua.acc_cnt++;
+	    cur_acc = &pjsua.acc[pjsua.acc_cnt - 1];
 	    break;
 
 	case OPT_USERNAME:   /* Default authentication user */
-	    if (!pjsua.cred_count) pjsua.cred_count = 1;
-	    pjsua.cred_info[0].username = pj_str(optarg);
+	    if (pjsua.cred_count==0) pjsua.cred_count=1;
+	    cur_cred->username = pj_str(optarg);
 	    break;
 
 	case OPT_REALM:	    /* Default authentication realm. */
-	    if (!pjsua.cred_count) pjsua.cred_count = 1;
-	    pjsua.cred_info[0].realm = pj_str(optarg);
+	    if (pjsua.cred_count==0) pjsua.cred_count=1;
+	    cur_cred->realm = pj_str(optarg);
 	    break;
 
 	case OPT_PASSWORD:   /* authentication password */
-	    if (!pjsua.cred_count) pjsua.cred_count = 1;
-	    pjsua.cred_info[0].data_type = 0;
-	    pjsua.cred_info[0].data = pj_str(optarg);
+	    if (pjsua.cred_count==0) pjsua.cred_count=1;
+	    cur_cred->data_type = 0;
+	    cur_cred->data = pj_str(optarg);
+	    break;
+
+	case OPT_NEXT_CRED: /* Next credential */
+	    pjsua.cred_count++;
+	    cur_cred = &pjsua.cred_info[pjsua.cred_count - 1];
 	    break;
 
@@ -412,4 +443,16 @@
 
 	case OPT_AUTO_PLAY:
+	    pjsua.auto_play = 1;
+	    break;
+
+	case OPT_AUTO_LOOP:
+	    pjsua.auto_loop = 1;
+	    break;
+
+	case OPT_AUTO_CONF:
+	    pjsua.auto_conf = 1;
+	    break;
+
+	case OPT_PLAY_FILE:
 	    pjsua.wav_file = optarg;
 	    break;
@@ -422,4 +465,12 @@
 	    }
 	    break;
+
+	case OPT_MAX_CALLS:
+	    pjsua.max_calls = atoi(optarg);
+	    if (pjsua.max_calls < 1 || pjsua.max_calls > 255) {
+		puts("Too many calls for max-calls (1-255)");
+		return -1;
+	    }
+	    break;
 	}
     }
@@ -430,8 +481,4 @@
     }
 
-    if (pjsua.reg_timeout == 0)
-	pjsua.reg_timeout = 3600;
-
-
     return PJ_SUCCESS;
 }
@@ -439,10 +486,10 @@
 
 
-static void print_invite_session(const char *title,
-				 struct pjsua_inv_data *inv_data, 
-				 char *buf, pj_size_t size)
+static void print_call(const char *title,
+		       int call_index, 
+		       char *buf, pj_size_t size)
 {
     int len;
-    pjsip_inv_session *inv = inv_data->inv;
+    pjsip_inv_session *inv = pjsua.calls[call_index].inv;
     pjsip_dialog *dlg = inv->dlg;
     char userinfo[128];
@@ -516,5 +563,4 @@
 void pjsua_dump(void)
 {
-    struct pjsua_inv_data *inv_data;
     char buf[128];
     unsigned old_decor;
@@ -534,21 +580,21 @@
     PJ_LOG(3,(THIS_FILE, "Dumping invite sessions:"));
 
-    if (pj_list_empty(&pjsua.inv_list)) {
+    if (pjsua.call_cnt == 0) {
 
 	PJ_LOG(3,(THIS_FILE, "  - no sessions -"));
 
     } else {
-
-	inv_data = pjsua.inv_list.next;
-
-	while (inv_data != &pjsua.inv_list) {
-
-	    print_invite_session("  ", inv_data, buf, sizeof(buf));
+	int i;
+
+	for (i=0; i<pjsua.max_calls; ++i) {
+
+	    if (pjsua.calls[i].inv == NULL)
+		continue;
+
+	    print_call("  ", i, buf, sizeof(buf));
 	    PJ_LOG(3,(THIS_FILE, "%s", buf));
 
-	    if (inv_data->session)
-		dump_media_session(inv_data->session);
-
-	    inv_data = inv_data->next;
+	    if (pjsua.calls[i].session)
+		dump_media_session(pjsua.calls[i].session);
 	}
     }
@@ -576,38 +622,94 @@
 
 /*
- * Save settings.
+ * Save account settings
  */
-pj_status_t pjsua_save_settings(const char *filename)
-{
-    unsigned i;
+static void save_account_settings(int acc_index, pj_str_t *result)
+{
+    char line[128];
+    pjsua_acc *acc = &pjsua.acc[acc_index];
+
+    
+    pj_ansi_sprintf(line, "#\n# Account %d:\n#\n", acc_index);
+    pj_strcat2(result, line);
+
+
+    /* Identity */
+    if (acc->local_uri.slen) {
+	pj_ansi_sprintf(line, "--id %.*s\n", 
+			(int)acc->local_uri.slen, 
+			acc->local_uri.ptr);
+	pj_strcat2(result, line);
+    }
+
+    /* Registrar server */
+    if (acc->reg_uri.slen) {
+	pj_ansi_sprintf(line, "--registrar %.*s\n",
+			      (int)acc->reg_uri.slen,
+			      acc->reg_uri.ptr);
+	pj_strcat2(result, line);
+
+	pj_ansi_sprintf(line, "--reg-timeout %u\n",
+			      acc->reg_timeout);
+	pj_strcat2(result, line);
+    }
+
+
+    /* Proxy */
+    if (acc->proxy.slen) {
+	pj_ansi_sprintf(line, "--proxy %.*s\n",
+			      (int)acc->proxy.slen,
+			      acc->proxy.ptr);
+	pj_strcat2(result, line);
+    }
+}
+
+
+
+/*
+ * Dump settings.
+ */
+int pjsua_dump_settings(char *buf, pj_size_t max)
+{
+    int acc_index;
+    int i;
     pj_str_t cfg;
     char line[128];
-    pj_pool_t *pool;
-    FILE *fhnd;
-
-    /* Create pool for temporary buffer. */
-    pool = pj_pool_create(&pjsua.cp.factory, "settings", 4000, 0, NULL);
-    if (!pool)
-	return PJ_ENOMEM;
-
-
-    cfg.ptr = pj_pool_alloc(pool, 3800);
-    if (!cfg.ptr) {
-	pj_pool_release(pool);
-	return PJ_EBUG;
-    }
+
+    cfg.ptr = buf;
     cfg.slen = 0;
 
 
-    /* Identity */
-    if (pjsua.local_uri.slen) {
-	pj_ansi_sprintf(line, "--id %.*s\n", 
-			(int)pjsua.local_uri.slen, 
-			pjsua.local_uri.ptr);
-	pj_strcat2(&cfg, line);
+    /* Logging. */
+    pj_strcat2(&cfg, "#\n# Logging options:\n#\n");
+    pj_ansi_sprintf(line, "--log-level %d\n",
+		    pjsua.log_level);
+    pj_strcat2(&cfg, line);
+
+    pj_ansi_sprintf(line, "--app-log-level %d\n",
+		    pjsua.app_log_level);
+    pj_strcat2(&cfg, line);
+
+    if (pjsua.log_filename) {
+	pj_ansi_sprintf(line, "--log-file %s\n",
+			pjsua.log_filename);
+	pj_strcat2(&cfg, line);
+    }
+
+
+    /* Save account settings. */
+    for (acc_index=0; acc_index < pjsua.acc_cnt; ++acc_index) {
+	
+	save_account_settings(acc_index, &cfg);
+
+	if (acc_index < pjsua.acc_cnt-1)
+	    pj_strcat2(&cfg, "--next-account\n");
     }
 
     /* Credentials. */
     for (i=0; i<pjsua.cred_count; ++i) {
+
+	pj_ansi_sprintf(line, "#\n# Credential %d:\n#\n", i);
+	pj_strcat2(&cfg, line);
+
 	if (pjsua.cred_info[i].realm.slen) {
 	    pj_ansi_sprintf(line, "--realm %.*s\n",
@@ -626,14 +728,11 @@
 			      pjsua.cred_info[i].data.ptr);
 	pj_strcat2(&cfg, line);
-    }
-
-    /* Registrar server */
-    if (pjsua.registrar_uri.slen) {
-	pj_ansi_sprintf(line, "--registrar %.*s\n",
-			      (int)pjsua.registrar_uri.slen,
-			      pjsua.registrar_uri.ptr);
-	pj_strcat2(&cfg, line);
-    }
-
+
+	if (i < pjsua.cred_count-1)
+	    pj_strcat2(&cfg, "--next-cred\n");
+    }
+
+
+    pj_strcat2(&cfg, "#\n# Network settings:\n#\n");
 
     /* Outbound proxy */
@@ -644,8 +743,4 @@
 	pj_strcat2(&cfg, line);
     }
-
-    /* Media */
-    if (pjsua.null_audio)
-	pj_strcat2(&cfg, "--null-audio\n");
 
 
@@ -673,4 +768,40 @@
 
 
+    pj_strcat2(&cfg, "#\n# Media settings:\n#\n");
+
+
+    /* Media */
+    if (pjsua.null_audio)
+	pj_strcat2(&cfg, "--null-audio\n");
+    if (pjsua.auto_play)
+	pj_strcat2(&cfg, "--auto-play\n");
+    if (pjsua.auto_loop)
+	pj_strcat2(&cfg, "--auto-loop\n");
+    if (pjsua.auto_conf)
+	pj_strcat2(&cfg, "--auto-conf\n");
+    if (pjsua.wav_file) {
+	pj_ansi_sprintf(line, "--play-file %s\n",
+			pjsua.wav_file);
+	pj_strcat2(&cfg, line);
+    }
+
+
+    pj_strcat2(&cfg, "#\n# User agent:\n#\n");
+
+    /* Auto-answer. */
+    if (pjsua.auto_answer != 0) {
+	pj_ansi_sprintf(line, "--auto-answer %d\n",
+			pjsua.auto_answer);
+	pj_strcat2(&cfg, line);
+    }
+
+    /* Max calls. */
+    pj_ansi_sprintf(line, "--max-calls %d\n",
+		    pjsua.max_calls);
+    pj_strcat2(&cfg, line);
+
+
+    pj_strcat2(&cfg, "#\n# Buddies:\n#\n");
+
     /* Add buddies. */
     for (i=0; i<pjsua.buddy_cnt; ++i) {
@@ -682,4 +813,37 @@
 
 
+    *(cfg.ptr + cfg.slen) = '\0';
+    return cfg.slen;
+}
+
+/*
+ * Save settings.
+ */
+pj_status_t pjsua_save_settings(const char *filename)
+{
+    pj_str_t cfg;
+    pj_pool_t *pool;
+    FILE *fhnd;
+
+    /* Create pool for temporary buffer. */
+    pool = pj_pool_create(&pjsua.cp.factory, "settings", 4000, 0, NULL);
+    if (!pool)
+	return PJ_ENOMEM;
+
+
+    cfg.ptr = pj_pool_alloc(pool, 3800);
+    if (!cfg.ptr) {
+	pj_pool_release(pool);
+	return PJ_EBUG;
+    }
+
+
+    cfg.slen = pjsua_dump_settings(cfg.ptr, 3800);
+    if (cfg.slen < 1) {
+	pj_pool_release(pool);
+	return PJ_ENOMEM;
+    }
+
+
     /* Write to file. */
     fhnd = fopen(filename, "wt");
Index: /pjproject/trunk/pjsip/src/pjsua/pjsua_pres.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua/pjsua_pres.c	(revision 235)
+++ /pjproject/trunk/pjsip/src/pjsua/pjsua_pres.c	(revision 236)
@@ -80,4 +80,5 @@
 static pj_bool_t pres_on_rx_request(pjsip_rx_data *rdata)
 {
+    int acc_index;
     pjsip_method *req_method = &rdata->msg_info.msg->line.req.method;
     pjsua_srv_pres *uapres;
@@ -94,7 +95,11 @@
     /* Incoming SUBSCRIBE: */
 
+    /* Find which account for the incoming request. */
+    acc_index = pjsua_find_account_for_incoming(rdata);
+
     /* Create UAS dialog: */
     status = pjsip_dlg_create_uas( pjsip_ua_instance(), rdata, 
-				   &pjsua.contact_uri, &dlg);
+				   &pjsua.acc[acc_index].contact_uri, 
+				   &dlg);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, 
@@ -131,5 +136,5 @@
 
     /* Add server subscription to the list: */
-    pj_list_push_back(&pjsua.pres_srv_list, uapres);
+    pj_list_push_back(&pjsua.acc[acc_index].pres_srv_list, uapres);
 
 
@@ -147,5 +152,5 @@
     pj_memset(&pres_status, 0, sizeof(pres_status));
     pres_status.info_cnt = 1;
-    pres_status.info[0].basic_open = pjsua.online_status;
+    pres_status.info[0].basic_open = pjsua.acc[acc_index].online_status;
     //Both pjsua.local_uri and pjsua.contact_uri are enclosed in "<" and ">"
     //causing XML parsing to fail.
@@ -175,11 +180,11 @@
 
 /* Refresh subscription (e.g. when our online status has changed) */
-static void refresh_server_subscription()
+static void refresh_server_subscription(int acc_index)
 {
     pjsua_srv_pres *uapres;
 
-    uapres = pjsua.pres_srv_list.next;
-
-    while (uapres != &pjsua.pres_srv_list) {
+    uapres = pjsua.acc[acc_index].pres_srv_list.next;
+
+    while (uapres != &pjsua.acc[acc_index].pres_srv_list) {
 	
 	pjsip_pres_status pres_status;
@@ -187,6 +192,6 @@
 
 	pjsip_pres_get_status(uapres->sub, &pres_status);
-	if (pres_status.info[0].basic_open != pjsua.online_status) {
-	    pres_status.info[0].basic_open = pjsua.online_status;
+	if (pres_status.info[0].basic_open != pjsua.acc[acc_index].online_status) {
+	    pres_status.info[0].basic_open = pjsua.acc[acc_index].online_status;
 	    pjsip_pres_set_status(uapres->sub, &pres_status);
 
@@ -299,11 +304,14 @@
 static void subscribe_buddy_presence(unsigned index)
 {
+    int acc_index;
     pjsip_dialog *dlg;
     pjsip_tx_data *tdata;
     pj_status_t status;
 
+    acc_index = pjsua.buddies[index].acc_index;
+
     status = pjsip_dlg_create_uac( pjsip_ua_instance(), 
-				   &pjsua.local_uri,
-				   &pjsua.contact_uri,
+				   &pjsua.acc[acc_index].local_uri,
+				   &pjsua.acc[acc_index].contact_uri,
 				   &pjsua.buddies[index].uri,
 				   NULL, &dlg);
@@ -326,5 +334,5 @@
 			     &pjsua.buddies[index]);
 
-    status = pjsip_pres_initiate(pjsua.buddies[index].sub, 60, &tdata);
+    status = pjsip_pres_initiate(pjsua.buddies[index].sub, -1, &tdata);
     if (status != PJ_SUCCESS) {
 	pjsua.buddies[index].sub = NULL;
@@ -382,5 +390,5 @@
 static void refresh_client_subscription(void)
 {
-    unsigned i;
+    int i;
 
     for (i=0; i<pjsua.buddy_cnt; ++i) {
@@ -416,8 +424,8 @@
  * Refresh presence
  */
-void pjsua_pres_refresh(void)
+void pjsua_pres_refresh(int acc_index)
 {
     refresh_client_subscription();
-    refresh_server_subscription();
+    refresh_server_subscription(acc_index);
 }
 
@@ -428,11 +436,18 @@
 void pjsua_pres_shutdown(void)
 {
-    unsigned i;
-
-    pjsua.online_status = 0;
+    int acc_index;
+    int i;
+
+    for (acc_index=0; acc_index<pjsua.acc_cnt; ++acc_index) {
+	pjsua.acc[acc_index].online_status = 0;
+    }
+
     for (i=0; i<pjsua.buddy_cnt; ++i) {
 	pjsua.buddies[i].monitor = 0;
     }
-    pjsua_pres_refresh();
+
+    for (acc_index=0; acc_index<pjsua.acc_cnt; ++acc_index) {
+	pjsua_pres_refresh(acc_index);
+    }
 }
 
@@ -442,20 +457,28 @@
 void pjsua_pres_dump(void)
 {
-    unsigned i;
+    int acc_index;
+    int i;
 
     PJ_LOG(3,(THIS_FILE, "Dumping pjsua server subscriptions:"));
-    if (pj_list_empty(&pjsua.pres_srv_list)) {
-	PJ_LOG(3,(THIS_FILE, "  - none - "));
-    } else {
-	struct pjsua_srv_pres *uapres;
-
-	uapres = pjsua.pres_srv_list.next;
-	while (uapres != &pjsua.pres_srv_list) {
-	
-	    PJ_LOG(3,(THIS_FILE, "  %10s %s",
-		      pjsip_evsub_get_state_name(uapres->sub),
-		      uapres->remote));
-
-	    uapres = uapres->next;
+    for (acc_index=0; acc_index < pjsua.acc_cnt; ++acc_index) {
+
+	PJ_LOG(3,(THIS_FILE, "  %.*s",
+		  (int)pjsua.acc[acc_index].local_uri.slen,
+		  pjsua.acc[acc_index].local_uri.ptr));
+
+	if (pj_list_empty(&pjsua.acc[acc_index].pres_srv_list)) {
+	    PJ_LOG(3,(THIS_FILE, "  - none - "));
+	} else {
+	    struct pjsua_srv_pres *uapres;
+
+	    uapres = pjsua.acc[acc_index].pres_srv_list.next;
+	    while (uapres != &pjsua.acc[acc_index].pres_srv_list) {
+	    
+		PJ_LOG(3,(THIS_FILE, "    %10s %s",
+			  pjsip_evsub_get_state_name(uapres->sub),
+			  uapres->remote));
+
+		uapres = uapres->next;
+	    }
 	}
     }
